---
title: HTMLElement
slug: Web/API/HTMLElement
tags:
  - API
  - HTML DOM
  - HTMLElement
  - Interface
  - NeedsNewLayout
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLElement</code></strong> interface represents any <a href="/en-US/docs/Web/HTML">HTML</a> element. Some elements directly implement this interface, while others implement it via an interface that inherits it.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{DOMxRef("Element")}}, and implements those from {{DOMxRef("DocumentAndElementEventHandlers")}}, {{DOMxRef("ElementCSSInlineStyle")}}, {{DOMxRef("GlobalEventHandlers")}}, {{DOMxRef("HTMLOrForeignElement")}} and {{DOMxRef("TouchEventHandlers")}}.</em></p>

<dl>
 <dt>{{DOMxRef("HTMLElement.accessKey")}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}} representing the access key assigned to the element.</dd>
 <dt>{{DOMxRef("HTMLElement.accessKeyLabel")}} {{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMString")}} containing the element's assigned access key.</dd>
 <dt>{{DOMxRef("HTMLElement.contentEditable")}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}}, where a value of <code>true</code> means the element is editable and a value of <code>false</code> means it isn't.</dd>
 <dt>{{DOMxRef("HTMLElement.isContentEditable")}} {{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("Boolean")}} that indicates whether or not the content of the element can be edited.</dd>
 <dt>{{DOMxRef("HTMLElement.contextMenu")}} {{Deprecated_Inline}}</dt>
 <dd>Is a {{DOMxRef("HTMLMenuElement")}} representing the contextual menu associated with the element. It may be <code>null</code>.</dd>
 <dt>{{DOMxRef("HTMLOrForeignElement.dataset")}} {{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMStringMap")}} with which script can read and write the element's <a href="/en-US/docs/Web/Guide/HTML/Using_data_attributes">custom data attributes</a> (<code>data-*</code>) .</dd>
 <dt>{{DOMxRef("HTMLElement.dir")}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}}, reflecting the <code>dir</code> global attribute, representing the directionality of the element. Possible values are <code>"ltr"</code>, <code>"rtl"</code>, and <code>"auto"</code>.</dd>
 <dt>{{DOMxRef("HTMLElement.draggable")}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} indicating if the element can be dragged.</dd>
 <dt>{{DOMxRef("HTMLElement.dropzone")}} {{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMSettableTokenList")}} reflecting the <code>dropzone</code> global attribute and describing the behavior of the element regarding a drop operation.</dd>
 <dt>{{DOMxRef("HTMLElement.hidden")}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} indicating if the element is hidden or not.</dd>
 <dt>{{DOMxRef("HTMLElement.inert")}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} indicating whether the user agent must act as though the given node is absent for the purposes of user interaction events, in-page text searches ("find in page"), and text selection.</dd>
 <dt>{{DOMxRef("HTMLElement.innerText")}}</dt>
 <dd>Represents the "rendered" text content of a node and its descendants. As a getter, it approximates the text the user would get if they highlighted the contents of the element with the cursor and then copied it to the clipboard.</dd>
 <dt>{{DOMxRef("HTMLElement.itemScope")}} {{Experimental_Inline}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} representing the item scope.</dd>
 <dt>{{DOMxRef("HTMLElement.itemType")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMSettableTokenList")}}…</dd>
 <dt>{{DOMxRef("HTMLElement.itemId")}} {{Experimental_Inline}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}} representing the item ID.</dd>
 <dt>{{DOMxRef("HTMLElement.itemRef")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMSettableTokenList")}}…</dd>
 <dt>{{DOMxRef("HTMLElement.itemProp")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMSettableTokenList")}}…</dd>
 <dt>{{DOMxRef("HTMLElement.itemValue")}} {{Experimental_Inline}}</dt>
 <dd>Returns a {{JSxRef("Object")}} representing the item value.</dd>
 <dt>{{DOMxRef("HTMLElement.lang")}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}} representing the language of an element's attributes, text, and element contents.</dd>
 <dt>{{DOMxRef("HTMLElement.noModule")}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} indicating whether an import script can be executed in user agents that support module scripts.</dd>
 <dt>{{DOMxRef("HTMLOrForeignElement.nonce")}}</dt>
 <dd>Returns the cryptographic number used once that is used by Content Security Policy to determine whether a given fetch will be allowed to proceed.</dd>
 <dt>{{DOMxRef("HTMLElement.offsetHeight")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>double</code> containing the height of an element, relative to the layout.</dd>
 <dt>{{DOMxRef("HTMLElement.offsetLeft")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>double</code>, the distance from this element's left border to its <code>offsetParent</code>'s left border.</dd>
 <dt>{{DOMxRef("HTMLElement.offsetParent")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("Element")}} that is the element from which all offset calculations are currently computed.</dd>
 <dt>{{DOMxRef("HTMLElement.offsetTop")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>double</code>, the distance from this element's top border to its <code>offsetParent</code>'s top border.</dd>
 <dt>{{DOMxRef("HTMLElement.offsetWidth")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>double</code> containing the width of an element, relative to the layout.</dd>
 <dt>{{DOMxRef("HTMLElement.properties")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("HTMLPropertiesCollection")}}…</dd>
 <dt>{{DOMxRef("HTMLElement.spellcheck")}}{{Gecko_MinVersion_Inline("1.9")}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} that controls <a href="/en-US/docs/HTML/Controlling_spell_checking_in_HTML_forms" title="en/Controlling_spell_checking_in_HTML_forms">spell-checking</a>. It is present on all HTML elements, though it doesn't have an effect on all of them.</dd>
 <dt>{{DOMxRef("HTMLElement.style")}}</dt>
 <dd>Is a {{DOMxRef("CSSStyleDeclaration")}}, an object representing the declarations of an element's style attributes.</dd>
 <dt>{{DOMxRef("HTMLOrForeignElement.tabIndex")}}</dt>
 <dd>Is a <code>long</code> representing the position of the element in the tabbing order.</dd>
 <dt>{{DOMxRef("HTMLElement.title")}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}} containing the text that appears in a popup box when mouse is over the element.</dd>
 <dt>{{DOMxRef("HTMLElement.translate")}} {{Experimental_Inline}}</dt>
 <dd>Is a {{JSxRef("Boolean")}} representing the translation.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p>Most event handler properties, of the form <code>onXYZ</code>, are defined on the {{DOMxRef("DocumentAndElementEventHandlers")}}, {{DOMxRef("GlobalEventHandlers")}} or {{DOMxRef("TouchEventHandlers")}} interfaces and implemented by <code>HTMLElement</code>. In addition, the following handlers are specific to <code>HTMLElement</code>.</p>

<dl>
 <dt>{{DOMxRef("HTMLElement.oncopy")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the <code>copy</code> event ({{bug("280959")}}).</dd>
 <dt>{{DOMxRef("HTMLElement.oncut")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the <code>cut</code> event ({{bug("280959")}}).</dd>
 <dt>{{DOMxRef("HTMLElement.onpaste")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the <code>paste</code> event ({{bug("280959")}}).</dd>
 <dt>{{DOMxRef("TouchEventHandlers.ontouchstart")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the {{domxref("Element/touchstart_event", "touchstart")}} event.</dd>
 <dt>{{DOMxRef("TouchEventHandlers.ontouchend")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the {{domxref("Element/touchend_event", "touchend")}} event.</dd>
 <dt>{{DOMxRef("TouchEventHandlers.ontouchmove")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the {{domxref("Element/touchmove_event", "touchmove")}} event.</dd>
 <dt>{{DOMxRef("TouchEventHandlers.ontouchenter")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the {{event("touchenter")}} event.</dd>
 <dt>{{DOMxRef("TouchEventHandlers.ontouchleave")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the {{event("touchleave")}} event.</dd>
 <dt>{{DOMxRef("TouchEventHandlers.ontouchcancel")}} {{Non-standard_Inline}}</dt>
 <dd>Returns the event handling code for the {{domxref("Element/touchcancel_event", "touchcancel")}} event.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{DOMxRef("Element")}}, and implements those from {{DOMxRef("DocumentAndElementEventHandlers")}}, {{DOMxRef("ElementCSSInlineStyle")}}, {{DOMxRef("GlobalEventHandlers")}}, {{DOMxRef("HTMLOrForeignElement")}} and {{DOMxRef("TouchEventHandlers")}}.</em></p>

<dl>
 <dt>{{DOMxRef("HTMLElement.attachInternals()")}} {{Experimental_Inline}}</dt>
 <dd>Attaches an {{DOMxRef("ElementInternals")}} instance to the custom element.</dd>
 <dt>{{DOMxRef("HTMLOrForeignElement.blur()")}}</dt>
 <dd>Removes keyboard focus from the currently focused element.</dd>
 <dt>{{DOMxRef("HTMLElement.click()")}}</dt>
 <dd>Sends a mouse click event to the element.</dd>
 <dt>{{DOMxRef("HTMLOrForeignElement.focus()")}}</dt>
 <dd>Makes the element the current keyboard focus.</dd>
 <dt>{{DOMxRef("HTMLElement.forceSpellCheck()")}} {{Experimental_Inline}}</dt>
 <dd>Runs the spell checker on the element's contents.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using <code>addEventListener()</code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt>{{domxref("HTMLElement/invalid_event", "invalid")}}</dt>
 <dd>Fired when an element does not satisfy its constraints during constraint validation.<br>
 Also available via the {{domxref("GlobalEventHandlers/oninvalid", "oninvalid")}} property.</dd>
</dl>

<h3 id="Animation_events">Animation events</h3>

<dl>
 <dt>{{domxref("HTMLElement/animationcancel_event", "animationcancel")}}</dt>
 <dd>Fired when an animation unexpectedly aborts.<br>
 Also available via the {{domxref("GlobalEventHandlers/onanimationcancel", "onanimationcancel")}} property.</dd>
 <dt>{{domxref("HTMLElement/animationend_event", "animationend")}}</dt>
 <dd>Fired when an animation has completed normally.<br>
 Also available via the {{domxref("GlobalEventHandlers/onanimationend", "onanimationend")}} property.</dd>
 <dt>{{domxref("HTMLElement/animationiteration_event", "animationiteration")}}</dt>
 <dd>Fired when an animation iteration has completed.<br>
 Also available via the {{domxref("GlobalEventHandlers/onanimationiteration", "onanimationiteration")}} property.</dd>
 <dt>{{domxref("HTMLElement/animationstart_event", "animationstart")}}</dt>
 <dd>Fired when an animation starts.<br>
 Also available via the {{domxref("GlobalEventHandlers/onanimationstart", "onanimationstart")}} property.</dd>
</dl>

<h3 id="Input_events">Input events</h3>

<dl>
 <dt>{{domxref("HTMLElement/beforeinput_event", "beforeinput")}}</dt>
 <dd>Fired when the value of an {{HTMLElement("input")}}, {{HTMLElement("select")}}, or {{HTMLElement("textarea")}} element is about to be modified.</dd>
 <dt>{{domxref("HTMLElement/input_event", "input")}}</dt>
 <dd>Fired when the <code>value</code> of an {{HTMLElement("input")}}, {{HTMLElement("select")}}, or {{HTMLElement("textarea")}} element has been changed.<br>
 Also available via the {{domxref("GlobalEventHandlers/oninput", "oninput")}} property.</dd>
 <dt>{{domxref("HTMLElement/change_event", "change")}}</dt>
 <dd>Fired when the <code>value</code> of an {{HTMLElement("input")}}, {{HTMLElement("select")}}, or {{HTMLElement("textarea")}} element has been changed and committed by the user. Unlike the {{domxref("HTMLElement/input_event", "input")}} event, the <code>change</code> event is not necessarily fired for each alteration to an element's <code>value</code>.</dd>
</dl>

<h3 id="Pointer_events">Pointer events</h3>

<dl>
 <dt>{{domxref("HTMLElement/gotpointercapture_event", "gotpointercapture")}}</dt>
 <dd>Fired when an element captures a pointer using {{domxref("Element/setPointerCapture", "setPointerCapture()")}}.<br>
 Also available via the {{domxref("GlobalEventHandlers/ongotpointercapture", "ongotpointercapture")}} property.</dd>
 <dt>{{domxref("HTMLElement/lostpointercapture_event", "lostpointercapture")}}</dt>
 <dd>Fired when a <a href="/en-US/docs/Web/API/Pointer_events#Pointer_capture">captured pointer</a> is released.<br>
 Also available via the {{domxref("GlobalEventHandlers/onlostpointercapture", "onlostpointercapture")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointercancel_event", "pointercancel")}}</dt>
 <dd>Fired when a pointer event is canceled.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointercancel", "onpointercancel")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointerdown_event", "pointerdown")}}</dt>
 <dd>Fired when a pointer becomes active.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointerdown", "onpointerdown")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointerenter_event", "pointerenter")}}</dt>
 <dd>Fired when a pointer is moved into the hit test boundaries of an element or one of its descendants.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointerenter", "onpointerenter")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointerleave_event", "pointerleave")}}</dt>
 <dd>Fired when a pointer is moved out of the hit test boundaries of an element.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointerleave", "onpointerleave")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointermove_event", "pointermove")}}</dt>
 <dd>Fired when a pointer changes coordinates.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointermove", "onpointermove")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointerout_event", "pointerout")}}</dt>
 <dd>Fired when a pointer is moved out of the <em>hit test</em> boundaries of an element (among other reasons).<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointerout", "onpointerout")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointerover_event", "pointerover")}}</dt>
 <dd>Fired when a pointer is moved into an element's hit test boundaries.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointerover", "onpointerover")}} property.</dd>
 <dt>{{domxref("HTMLElement/pointerup_event", "pointerup")}}</dt>
 <dd>Fired when a pointer is no longer active.<br>
 Also available via the {{domxref("GlobalEventHandlers/onpointerup", "onpointerup")}} property.</dd>
</dl>

<h3 id="Transition_events">Transition events</h3>

<dl>
 <dt>{{domxref("HTMLElement/transitioncancel_event", "transitioncancel")}}</dt>
 <dd>Fired when a <a href="/en-US/docs/Web/CSS/CSS_Transitions/Using_CSS_transitions">CSS transition</a> is canceled.<br>
 Also available via the {{domxref("GlobalEventHandlers/ontransitioncancel", "ontransitioncancel")}} property.</dd>
 <dt>{{domxref("HTMLElement/transitionend_event", "transitionend")}}</dt>
 <dd>Fired when a <a href="/en-US/docs/Web/CSS/CSS_Transitions/Using_CSS_transitions">CSS transition</a> has completed.<br>
 Also available via the {{domxref("GlobalEventHandlers/ontransitionend", "ontransitionend")}} property.</dd>
 <dt>{{domxref("HTMLElement/transitionrun_event", "transitionrun")}}</dt>
 <dd>Fired when a <a href="/en-US/docs/Web/CSS/CSS_Transitions/Using_CSS_transitions">CSS transition</a> is first created.<br>
 Also available via the {{domxref("GlobalEventHandlers/ontransitionrun", "ontransitionrun")}} property.</dd>
 <dt>{{domxref("HTMLElement/transitionstart_event", "transitionstart")}}</dt>
 <dd>Fired when a <a href="/en-US/docs/Web/CSS/CSS_Transitions/Using_CSS_transitions">CSS transition</a> has actually started.<br>
 Also available via the {{domxref("GlobalEventHandlers/ontransitionstart", "ontransitionstart")}} property.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSSOM View', '#extensions-to-the-htmlelement-interface', 'HTMLElement')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
   <td>Added the following properties: <code>offsetParent</code>, <code>offsetTop</code>, <code>offsetLeft</code>, <code>offsetWidth</code>, and <code>offsetHeight</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'elements.html#htmlelement', 'HTMLElement')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Added the following properties: <code>translate</code>, <code>itemScope</code>, <code>itemType</code>, <code>itemId</code>, <code>itemRef</code>, <code>itemProp</code>, <code>properties</code>, and <code>itemValue</code>.<br>
    Added the following method: <code>forceSpellcheck()</code>.<br>
    Moved the <code>onXYZ</code> attributes to the {{DOMxRef("GlobalEventHandlers")}} interface and added an inheritance from it.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'dom.html#htmlelement', 'HTMLElement')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Added the following properties: <code>dataset</code>, <code>hidden</code>, <code>tabIndex</code>, <code>accessKey</code>, <code>accessKeyLabel</code>, <code>draggable</code>, <code>dropzone</code>, <code>contentEditable</code>, <code>isContentEditable</code>, <code>contextMenu</code>, <code>spellcheck</code>, <code>commandType</code>, <code>commandLabel</code>, <code>commandIcon</code>, <code>commandHidden</code>, <code>commandDisabled</code>, <code>commandChecked</code>, <code>style</code>, and all the <code>onXYZ</code> properties.<br>
    Moved the <code>id</code> and <code>className</code> properties to the {{DOMxRef("Element")}} interface.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 HTML', 'html.html#ID-011100101', 'HTMLElement')}}</td>
   <td>{{Spec2('DOM2 HTML')}}</td>
   <td>No change from {{SpecName('DOM2 HTML')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-html.html#ID-011100101', 'HTMLElement')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Element")}}</li>
</ul>
